Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.1.1.3.4.2.2.3
retrieving revision 1.1.1.3.4.2.2.4
diff -u -r1.1.1.3.4.2.2.3 -r1.1.1.3.4.2.2.4
--- squid/src/main.c	3 Jun 2001 19:41:48 -0000	1.1.1.3.4.2.2.3
+++ squid/src/main.c	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.2.2.4
@@ -1,11 +1,11 @@
 
 /*
- * $Id: main.c,v 1.1.1.3.4.2.2.3 2001/06/03 19:41:48 serassio Exp $
+ * $Id: main.c,v 1.1.1.3.4.2.2.4 2001/06/14 20:36:16 serassio Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
  *
- * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
  * ----------------------------------------------------------
  *
  *  Squid is the result of efforts by numerous individuals from the
@@ -35,11 +35,28 @@
 
 #include "squid.h"
 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+#include <windows.h>
+#include <process.h>
+#ifdef _SQUID_MSWIN_
+#include <direct.h>
+#endif
+static int opt_install_service = FALSE;
+static int opt_remove_service = FALSE;
+static int opt_signal_service = FALSE;
+extern void WIN32_svcstatusupdate(DWORD);
+void WINAPI WIN32_svcHandler(DWORD);
+#endif
+
 /* for error reporting from xmalloc and friends */
 extern void (*failure_notify) (const char *);
 
 static int opt_send_signal = -1;
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+static int opt_no_daemon = 1;
+#else
 static int opt_no_daemon = 0;
+#endif
 static int opt_parse_cfg_only = 0;
 static int httpPortNumOverride = 1;
 static int icpPortNumOverride = 1;	/* Want to detect "-u 0" */
@@ -53,8 +70,6 @@
 
 static void mainRotate(void);
 static void mainReconfigure(void);
-static SIGHDLR rotate_logs;
-static SIGHDLR reconfigure;
 #if ALARM_UPDATES_TIME
 static SIGHDLR time_tick;
 #endif
@@ -73,22 +88,6 @@
 static void mainSetCwd(void);
 static int checkRunningPid(void);
 
-#ifdef _SQUID_MSWIN_
-#include <direct.h>
-#include <process.h>
-extern void Win32SockCleanup(void);
-static BOOL opt_install_service=FALSE;
-static BOOL opt_remove_service=FALSE;
-static BOOL opt_config_file=FALSE;
-static BOOL eventrunning=FALSE;
-static SERVICE_STATUS svcStatus;
-static SERVICE_STATUS_HANDLE svcHandle;
-#ifndef _DEBUG
-#define SERVICE
-#endif
-#else
-static void watch_child(char **);
-#endif
 #if TEST_ACCESS
 #include "test_access.c"
 #endif
@@ -97,36 +96,33 @@
 usage(void)
 {
     fprintf(stderr,
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	"Usage: %s [-dhirsvzCDFRVYX] [-f config-file] [-[au] port] [-k signal] [-n name]\n"
+#else
 	"Usage: %s [-dhsvzCDFNRVYX] [-f config-file] [-[au] port] [-k signal]\n"
+#endif
 	"       -a port   Specify HTTP port number (default: %d).\n"
 	"       -d level  Write debugging to stderr also.\n"
-#ifdef SERVICE
-    "       -f file   Set Windows NT Registry to use given config-file instead of\n"
-	"                 %s\n"
-#else
-	"       -f file   Use given config-file instead of\n"
-	"                 %s\n"
-#endif
 	"       -h        Print help message.\n"
-#ifdef SERVICE
-	"       -i        Installs the " SQUID_SERVICE_NAME " service.\n"
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	"       -i        Installs as a Windows Service (see -n option).\n"
 #endif
 	"       -k reconfigure|rotate|shutdown|interrupt|kill|debug|check|parse\n"
 	"                 Parse configuration file, then send signal to \n"
 	"                 running copy (except -k parse) and exit.\n"
-#ifdef SERVICE
-	"       -r        Removes the " SQUID_SERVICE_NAME " service.\n"
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	"       -n name   Specify Windows Service name to use for service operations\n"
+	"                 default is: " _WIN_SQUID_DEFAULT_SERVICE_NAME ".\n"
+	"       -r        Removes a Windows Service (see -n option).\n"
 #endif
-#ifndef _SQUID_MSWIN_
 	"       -s        Enable logging to syslog.\n"
-#endif
 	"       -u port   Specify ICP port number (default: %d), disable with 0.\n"
 	"       -v        Print version.\n"
 	"       -z        Create swap directories\n"
 	"       -C        Do not catch fatal signals.\n"
 	"       -D        Disable initial DNS tests.\n"
 	"       -F        Don't serve any requests until store is rebuilt.\n"
-#ifndef _SQUID_MSWIN_
+#if !(defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)))
 	"       -N        No daemon mode.\n"
 #endif
 	"       -R        Do not set REUSEADDR on port.\n"
@@ -141,18 +137,12 @@
 mainParseOptions(int argc, char *argv[])
 {
 
-#ifdef _SQUID_MSWIN_
-	char *optarg;
-	char c;
-	int i=1;
-
-	while (i<argc){
-		optarg=argv[i],c=optarg[1],	optarg=argv[++i];
-		if (i<argc && strchr(optarg,'-')==NULL) i++;
-#else
     extern char *optarg;
     int c;
 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    while ((c = getopt(argc, argv, "CDFRSVYXa:d:f:hik:m::n:rsu:vz?")) != -1) {
+#else
     while ((c = getopt(argc, argv, "CDFNRSVYXa:d:f:hk:m::su:vz?")) != -1) {
 #endif
 	switch (c) {
@@ -165,7 +155,7 @@
 	case 'F':
 	    opt_foreground_rebuild = 1;
 	    break;
-#ifndef _SQUID_MSWIN_
+#if !(defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)))
 	case 'N':
 	    opt_no_daemon = 1;
 	    break;
@@ -193,18 +183,15 @@
 	    opt_debug_stderr = atoi(optarg);
 	    break;
 	case 'f':
-#ifdef SERVICE
-		opt_config_file=TRUE;
-#endif
-		xfree(ConfigFile);
+	    xfree(ConfigFile);
 	    ConfigFile = xstrdup(optarg);
 	    break;
 	case 'h':
 	    usage();
 	    break;
-#ifdef SERVICE
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
 	case 'i':
-	    opt_install_service=TRUE;
+	    opt_install_service = TRUE;
 	    break;
 #endif
 	case 'k':
@@ -254,16 +241,19 @@
 		fatal("Need to configure --enable-xmalloc-debug-trace to use -m option");
 #endif
 	    }
-#ifdef SERVICE
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	case 'n':
+	    xfree(WIN32_Service_name);
+	    WIN32_Service_name = xstrdup(optarg);
+	    opt_signal_service = TRUE;
+	    break;
 	case 'r':
 	    opt_remove_service = TRUE;
 	    break;
 #endif
-#ifndef _SQUID_MSWIN_
 	case 's':
 	    opt_syslog_enable = 1;
 	    break;
-#endif
 	case 'u':
 	    icpPortNumOverride = atoi(optarg);
 	    if (icpPortNumOverride < 0)
@@ -271,6 +261,9 @@
 	    break;
 	case 'v':
 	    printf("Squid Cache: Version %s\n", version_string);
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	    printf("Compiled as Windows System Service.\n");
+#endif
 	    exit(0);
 	    /* NOTREACHED */
 	case 'z':
@@ -285,7 +278,7 @@
 }
 
 /* ARGSUSED */
-static void
+void
 rotate_logs(int sig)
 {
     do_rotate = 1;
@@ -310,7 +303,7 @@
 #endif
 
 /* ARGSUSED */
-static void
+void
 reconfigure(int sig)
 {
     do_reconfigure = 1;
@@ -451,11 +444,10 @@
 static void
 setEffectiveUser(void)
 {
-#ifndef _SQUID_MSWIN_
     leave_suid();		/* Run as non privilegied user */
-#ifdef _SQUID_OS2_
+#if defined(_SQUID_OS2_) || defined(_SQUID_MSWIN_)
     return;
-#endif
+#else
     if (geteuid() == 0) {
 	debug(0, 0) ("Squid is not safe to run as root!  If you must\n");
 	debug(0, 0) ("start Squid as root, then you must configure\n");
@@ -463,7 +455,7 @@
 	debug(0, 0) ("'cache_effective_user' option in the config file.\n");
 	fatal("Don't run Squid as root, set 'cache_effective_user'!");
     }
-#endif 
+#endif
 }
 
 static void
@@ -498,11 +490,9 @@
 mainInitialize(void)
 {
     /* chroot if configured to run inside chroot */
-#ifndef _SQUID_MSWIN_
     if (Config.chroot_dir && chroot(Config.chroot_dir)) {
 	fatal("failed to chroot");
     }
-#endif
     if (opt_catch_signals) {
 	squid_signal(SIGSEGV, death, SA_NODEFER | SA_RESETHAND);
 	squid_signal(SIGBUS, death, SA_NODEFER | SA_RESETHAND);
@@ -516,16 +506,21 @@
 	Config.Sockaddr.http->s.sin_port = htons(httpPortNumOverride);
     if (icpPortNumOverride != 1)
 	Config.Port.icp = (u_short) icpPortNumOverride;
-#ifndef _DEBUG
+
     _db_init(Config.Log.log, Config.debugOptions);
     fd_open(fileno(debug_log), FD_LOG, Config.Log.log);
-#endif
 #if MEM_GEN_TRACE
     log_trace_init("/tmp/squid.alloc");
 #endif
     debug(1, 0) ("Starting Squid Cache version %s for %s...\n",
 	version_string,
 	CONFIG_HOST_TYPE);
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+    if (WIN32_run_mode == _WIN_SQUID_RUN_MODE_SERVICE)
+	debug(1, 0) ("Running as %s Windows System Service on %s\n", WIN32_Service_name, WIN32_OS_string);
+    else
+	debug(1, 0) ("Running on %s\n",WIN32_OS_string);
+#endif
     debug(1, 1) ("Process ID %d\n", (int) getpid());
     debug(1, 1) ("With %d file descriptors available\n", Squid_MaxFD);
 
@@ -615,68 +610,9 @@
     configured_once = 1;
 }
 
-#ifdef SERVICE
-VOID WINAPI svcHandler (DWORD Opcode) 
-{ 
-    DWORD status; 
- 
-    switch(Opcode) 
-    { 
-        case SERVICE_CONTROL_STOP: 
-        case SERVICE_CONTROL_SHUTDOWN: 
-        // Do whatever it takes to stop here. 
-            svcStatus.dwWin32ExitCode = 0; 
-            svcStatus.dwCurrentState  = SERVICE_STOP_PENDING; 
-            svcStatus.dwCheckPoint    = 0; 
-            svcStatus.dwWaitHint      = 10000; 
-			shut_down(SIGTERM);
-            if (!SetServiceStatus (svcHandle,  &svcStatus))
-            { 
-                status = GetLastError(); 
-                debug(1,1)(" SetServiceStatus error  %ld\n",status); 
-            } 
-             debug(1,1)("Leaving Squid service \n"); 
-            return; 
-         case SERVICE_CONTROL_INTERROGATE: 
-        // Fall through to send current status. 
-			if (!SetServiceStatus (svcHandle,  &svcStatus)) 
-			{ 
-				status = GetLastError(); 
-				debug(1,1)(" SetServiceStatus error  %ld\n",status); 
-			} 
-            break; 
-		 case SQUID_SERVICE_CONTROL_ROTATE:
-			rotate_logs(SIGUSR1);
-			break;
-		 case SQUID_SERVICE_CONTROL_RECONFIGURE:
-			reconfigure(SIGHUP);
-			break;
-		 case SQUID_SERVICE_CONTROL_DEBUG:
-			sigusr2_handle(SIGUSR2);
-			break;
-        case SQUID_SERVICE_CONTROL_INTERRUPT: 
-        // Do whatever it takes to stop here. 
-            svcStatus.dwWin32ExitCode = 0; 
-            svcStatus.dwCurrentState  = SERVICE_STOP_PENDING; 
-            svcStatus.dwCheckPoint    = 0; 
-            svcStatus.dwWaitHint      = 10000; 
-			shut_down(SIGINT);
-            if (!SetServiceStatus (svcHandle,  &svcStatus))
-            { 
-                status = GetLastError(); 
-                debug(1,1)(" SetServiceStatus error  %ld\n",status); 
-            } 
-            debug(1,1)("Leaving Squid service \n"); 
-			break;
-
-         default: 
-            debug(1,1)("Unrecognized opcode %ld\n", Opcode); 
-    } 
-    return; 
-} 
-
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+/* When USE_WIN32_SERVICE is defined, the main function is placed in win32.c */
 void WINAPI SquidMain(DWORD argc, char **argv)
-
 #else
 int
 main(int argc, char **argv)
@@ -687,56 +623,24 @@
     time_t loop_delay;
     mode_t oldmask;
 	
-#ifdef SERVICE
-	TCHAR path[512];
-    HKEY hndKey;
-#endif
-	debug_log=stderr;
-#ifdef SERVICE
-	if (argc==1)
-	{
-		svcHandle=RegisterServiceCtrlHandler( SQUID_SERVICE_NAME, svcHandler); 
-		if(svcHandle==0) return;
-	}
-    GetModuleFileName(NULL, path, 512);
-	_strset(path+strlen(path)-9,0);
-	if (SetCurrentDirectory(path)==0) return;
-    xfree(ConfigFile);
-
-/* get config file from Windows Registry */
-	
-  	if (RegOpenKey(HKEY_LOCAL_MACHINE,"SOFTWARE\\GNU\\SquidNT\\2.3Stable4",&hndKey) == ERROR_SUCCESS) {
-  		DWORD Type = 0;
-  		DWORD Size = 0;
-  		LONG	Result;
-		Result = RegQueryValueEx(hndKey,"ConfigFile",NULL,&Type,NULL,&Size);
-		if (Result == ERROR_SUCCESS && Size) {
-			ConfigFile = xmalloc(Size);
-			RegQueryValueEx(hndKey,"ConfigFile",NULL,&Type,ConfigFile,&Size);
-		} else
-			ConfigFile = xstrdup(DefaultConfigFile);
- 	 	RegCloseKey(hndKey);
-	} else {
-		ConfigFile = xstrdup(DefaultConfigFile);
-	}
-
-	if (argc==1){
-    svcStatus.dwServiceType=SERVICE_WIN32_OWN_PROCESS;
-	svcStatus.dwCurrentState=SERVICE_START_PENDING; 
-    svcStatus.dwControlsAccepted=SERVICE_ACCEPT_STOP |SERVICE_ACCEPT_SHUTDOWN;
-	svcStatus.dwWin32ExitCode=0; 
-    svcStatus.dwServiceSpecificExitCode=0;
-	svcStatus.dwCheckPoint=0; 
-    svcStatus.dwWaitHint=10000; 
-	SetServiceStatus( svcHandle,&svcStatus); 
-	}
-#endif
-#ifndef _SQUID_MSWIN_ 
+    debug_log=stderr;
     if (FD_SETSIZE < Squid_MaxFD)
 	Squid_MaxFD = FD_SETSIZE;
+
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+#ifdef USE_WIN32_SERVICE
+    if (WIN32_Subsystem_Init())
+	return;
+/*    opt_no_daemon=(WIN32_run_mode == _WIN_SQUID_RUN_MODE_SERVICE) ? 0 : 1; */
 #else
-	Squid_MaxFD = 20*SQUID_MAXFD;
+    {
+	int WIN32_init_err;	
+	if ((WIN32_init_err = WIN32_Subsystem_Init()))
+	    return WIN32_init_err;
+    }
 #endif
+#endif
+
    /* call mallopt() before anything else */
 #if HAVE_MALLOPT
 #ifdef M_GRAIN
@@ -759,11 +663,9 @@
      * set.  Unfortunately, there is no way to get the current
      * umask value without setting it.
      */
-#ifndef _SQUID_MSWIN_
     oldmask = umask(S_IRWXO);
     if (oldmask)
 	umask(oldmask);
-#endif
 
     memset(&local_addr, '\0', sizeof(struct in_addr));
     safe_inet_addr(localhost, &local_addr);
@@ -777,28 +679,20 @@
     squid_start = current_time;
     failure_notify = fatal_dump;
 
-#ifdef SERVICE
-	if (argc==1){
-	svcStatus.dwCheckPoint++; 
-	SetServiceStatus( svcHandle,&svcStatus); 
-	}
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    WIN32_svcstatusupdate(SERVICE_START_PENDING);
 #endif
     mainParseOptions(argc, argv);
 
-#ifdef SERVICE
-	if(opt_install_service) {
-		InstallService();
-		if (!opt_config_file)
-			return;
-	}
-	if(opt_config_file) {
-	    store_key("ConfigFile", REG_SZ,(unsigned char*) ConfigFile, strlen(ConfigFile)+1);
-		return;
-	}
-	if(opt_remove_service) {
-		RemoveService();
-		return;
-	}
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    if (opt_install_service) {
+	WIN32_InstallService();
+	return;
+    }
+    if (opt_remove_service) {
+	WIN32_RemoveService();
+	return;
+    }
 #endif
     /* parse configuration file
      * note: in "normal" case this used to be called from mainInitialize() */
@@ -813,23 +707,18 @@
 #endif
 	memInit();		/* memInit is required for config parsing */
 	eventInit();		/* eventInit() is required for config parsing */
-#ifdef _SQUID_MSWIN_
-	Win32SockInit();
-#endif
 	parse_err = parseConfigFile(ConfigFile);
 
 	if (opt_parse_cfg_only)
-#ifdef SERVICE	    
-		return ;
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	    return;
 #else
-		return parse_err;
+	    return parse_err;
 #endif
     }
-#ifndef _SQUID_MSWIN_
     if (-1 == opt_send_signal)
 	if (checkRunningPid())
 	    exit(1);
-#endif
 
 #if TEST_ACCESS
     comm_init();
@@ -842,31 +731,26 @@
     /* send signal to running copy and exit */
     if (opt_send_signal != -1) {
 	/* chroot if configured to run inside chroot */
-#ifndef _SQUID_MSWIN_
 	if (Config.chroot_dir && chroot(Config.chroot_dir)) {
 	    fatal("failed to chroot");
 	}
-#endif
 	sendSignal();
 	/* NOTREACHED */
     }
     if (opt_create_swap_dirs) {
-#ifndef _SQUID_MSWIN_
 	/* chroot if configured to run inside chroot */
 	if (Config.chroot_dir && chroot(Config.chroot_dir)) {
 	    fatal("failed to chroot");
 	}
 	setEffectiveUser();
-#endif
 	debug(0, 0) ("Creating Swap Directories\n");
 	storeCreateSwapDirectories();
-#ifndef SERVICE
-	return 0;
-#else
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
 	return;
+#else
+	return 0;
 #endif
     }
-#ifndef _SQUID_MSWIN_
     if (!opt_no_daemon)
 	watch_child(argv);
     setMaxFD();
@@ -874,41 +758,24 @@
     if (opt_catch_signals)
 	for (n = Squid_MaxFD; n > 2; n--)
 	    close(n);
-#endif
 
     /* init comm module */
     comm_init();
     comm_select_init();
 
-#ifndef SERVICE
     if (opt_no_daemon) {
 	/* we have to init fdstat here. */
 	fd_open(0, FD_LOG, "stdin");
 	fd_open(1, FD_LOG, "stdout");
 	fd_open(2, FD_LOG, "stderr");
     }
-#else	
-	svcStatus.dwCheckPoint++; 
-	SetServiceStatus( svcHandle,&svcStatus); 
-#endif
-#ifdef _SQUID_MSWIN_
-#ifdef _DEBUG
-	for (n=0;n<MAX_DEBUG_SECTIONS;n++)
-		debugLevels[n]=1;
-#endif
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    WIN32_svcstatusupdate(SERVICE_START_PENDING);
 #endif
 	mainInitialize();
 	
-#ifdef _SQUID_MSWIN_
-#ifdef SERVICE	
-	svcStatus.dwCheckPoint++; 
-	svcStatus.dwCurrentState=SERVICE_RUNNING; 
-	SetServiceStatus( svcHandle,&svcStatus); 
-#endif
-#ifdef _DEBUG
-	for (n=0;n<MAX_DEBUG_SECTIONS;n++)
-		debugLevels[n]=1;
-#endif
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    WIN32_svcstatusupdate(SERVICE_RUNNING);
 #endif
 
     /* main loop */
@@ -928,9 +795,8 @@
 	    do_shutdown = 0;
 	    shutting_down = 1;
 	    serverConnectionsClose();
-#ifdef SERVICE
-		svcStatus.dwCheckPoint++; 
-		SetServiceStatus( svcHandle,&svcStatus); 
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	    WIN32_svcstatusupdate(SERVICE_STOP_PENDING);
 #endif
 	    dnsShutdown();
 #if !USE_DNSSERVERS
@@ -940,17 +806,7 @@
 	    authenticateShutdown();
 	    eventAdd("SquidShutdown", SquidShutdown, NULL, (double) (wait + 1), 1);
 	}
-#ifdef _DEBUG
-	for (n=0;n<MAX_DEBUG_SECTIONS;n++)
-		debugLevels[n]=1;
-#endif
 	eventRun();
-
-#ifdef _DEBUG
-	for (n=0;n<MAX_DEBUG_SECTIONS;n++)
-		debugLevels[n]=3;
-	debugLevels[5]=5;
-#endif
 	if ((loop_delay = eventNextTime()) < 0)
 	    loop_delay = 0;
 #if HAVE_POLL
@@ -978,28 +834,25 @@
 	}
     }
     /* NOTREACHED */
-#ifndef SERVICE
-    return 0;
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+    return;
 #else
-	return;
+    return 0;
 #endif
 }
 
 static void
 sendSignal(void)
 {
-
     pid_t pid;
-#ifdef _SQUID_MSWIN_
-    SERVICE_STATUS ssStatus; 
-    DWORD fdwAccess, fdwControl; 
-    SC_HANDLE   schService;
-    SC_HANDLE   schSCManager;
-#endif
     debug_log = stderr;
     pid = readPidFile();
     if (pid > 1) {
-#ifndef _SQUID_MSWIN_
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	if (opt_signal_service)
+	    WIN32_sendSignal(opt_send_signal);
+	else {
+#endif
 	if (kill(pid, opt_send_signal) &&
 	/* ignore permissions if just running check */
 	    !(opt_send_signal == 0 && errno == EPERM)) {
@@ -1008,84 +861,8 @@
 		opt_send_signal, (int) pid, xstrerror());
 	    exit(1);
 	}
-#else
-	    schSCManager = OpenSCManager(
-                        NULL,                   // machine (NULL == local)
-                        NULL,                   // database (NULL == default)
-                        SC_MANAGER_ALL_ACCESS   // access required
-                        );
-	    if (!schSCManager)
-		{	
-			debug(1,1)("OpenSCManager failed");
-			exit(1);
-		}
-		// The required service object access depends on the control. 
-		switch (opt_send_signal) 
-		{ 
-			case 0: // SIGNULL
-				fdwAccess = SERVICE_INTERROGATE; 
-				fdwControl = SERVICE_CONTROL_INTERROGATE;
-				break; 
-			case SIGUSR1: 
-				fdwAccess = SERVICE_USER_DEFINED_CONTROL; 
-				fdwControl = SQUID_SERVICE_CONTROL_ROTATE;
-				break; 
-			case SIGUSR2: 
-				fdwAccess = SERVICE_USER_DEFINED_CONTROL; 
-				fdwControl = SQUID_SERVICE_CONTROL_DEBUG;
-				break; 
-			case SIGHUP: 
-				fdwAccess = SERVICE_USER_DEFINED_CONTROL; 
-				fdwControl = SQUID_SERVICE_CONTROL_RECONFIGURE;
-				break; 
-			case SIGTERM: 
-				fdwAccess = SERVICE_STOP; 
-				fdwControl = SERVICE_CONTROL_STOP;
-				break; 
-			case SIGINT: 
-			case SIGKILL: 
-				fdwAccess = SERVICE_USER_DEFINED_CONTROL; 
-				fdwControl = SQUID_SERVICE_CONTROL_INTERRUPT;
-				break; 
-			default:
-				exit(1);
-		} 
- 		// Open a handle to the service. 
- 		schService = OpenService( 
-			schSCManager,        // SCManager database 
-			SQUID_SERVICE_NAME,  // name of service 
-			fdwAccess);          // specify access 
-		if (schService == NULL)
-		{
-			fprintf(stderr, "%s: ERROR: Could not open Service %s\n", appname, SQUID_SERVICE_NAME);
-			exit(1);
-		}
-		else
-		{ 
-			// Send a control value to the service. 
- 			if (! ControlService( 
-				schService,   // handle of service 
-				fdwControl,   // control value to send 
-				&ssStatus) )  // address of status info 
-			{
-				fprintf(stderr, "%s: ERROR: Could not Control Service %s\n", appname, SQUID_SERVICE_NAME);
-				exit(1);
-			}
-			else
-			{
-				// Print the service status. 
- 				printf("\nStatus of %s Service:\n", SQUID_SERVICE_NAME);
-				printf("  Service Type: 0x%x\n", ssStatus.dwServiceType); 
-				printf("  Current State: 0x%x\n", ssStatus.dwCurrentState); 
-				printf("  Controls Accepted: 0x%x\n", ssStatus.dwControlsAccepted); 
-				printf("  Exit Code: %d\n", ssStatus.dwWin32ExitCode); 
-				printf("  Service Specific Exit Code: %d\n", ssStatus.dwServiceSpecificExitCode); 
-				printf("  Check Point: %d\n", ssStatus.dwCheckPoint); 
-				printf("  Wait Hint: %d\n", ssStatus.dwWaitHint); 
-			}
-			CloseServiceHandle(schService);
-		}
-		CloseServiceHandle(schSCManager);
+#if defined(USE_WIN32_SERVICE) && (defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_))
+	}
 #endif
     } else {
 	fprintf(stderr, "%s: ERROR: No running copy\n", appname);
@@ -1095,7 +872,6 @@
     exit(0);
 }
 
-#ifndef _SQUID_MSWIN_
 static int
 checkRunningPid(void)
 {
@@ -1113,6 +889,7 @@
 static void
 watch_child(char *argv[])
 {
+#ifndef _SQUID_MSWIN_
     char *prog;
     int failcount = 0;
     time_t start;
@@ -1188,18 +965,12 @@
 	sleep(3);
     }
     /* NOTREACHED */
-}
 #endif
+}
 
 static void
 SquidShutdown(void *unused)
 {
-#ifdef SERVICE
-	const char a[2][20]={"squid","stopped"};
-
-	svcStatus.dwCheckPoint++; 
-	SetServiceStatus( svcHandle,&svcStatus); 
-#endif
     debug(1, 1) ("Shutting down...\n");
     if (Config.pidFilename && strcmp(Config.pidFilename, "none")) {
 	enter_suid();
@@ -1270,42 +1041,9 @@
 	version_string);
     if (debug_log)
 	fclose(debug_log);
-#ifdef _SQUID_MSWIN_
-	ServiceExit(0);
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+    WIN32_Exit(0);
 #else
-	exit(0);
-#endif
-}
-
-#ifdef SERVICE
-#include<conio.h>
-int main(int argc, char **argv) {
-	SERVICE_TABLE_ENTRY   DispatchTable[] =     { 
-        { SQUID_SERVICE_NAME, SquidMain     }, 
-        { NULL,              NULL                }     
-	};  
-	if (argc>1) SquidMain(argc, argv);
-	else
-		if (!StartServiceCtrlDispatcher( DispatchTable))     
-        _cprintf(" StartServiceCtrlDispatcher error = %d\n", GetLastError());     
-}
-#endif
-
-#ifdef _SQUID_MSWIN_
-
-VOID ServiceExit(int ExitStatus)
-{
-	Win32SockCleanup();
-#ifdef SERVICE
-	if (ExitStatus)
-	{
-		svcStatus.dwWin32ExitCode=ERROR_SERVICE_SPECIFIC_ERROR;
-		svcStatus.dwServiceSpecificExitCode=1;
-	}
-	svcStatus.dwCurrentState=SERVICE_STOPPED; 
-	SetServiceStatus( svcHandle,&svcStatus); 
-//	ReportEvent(RegisterEventSource(NULL,NULL),EVENTLOG_INFORMATION_TYPE,0,1,NULL,1,0,(const char**)a,NULL);
-#endif
     exit(0);
-}
 #endif
+}
Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.1.1.3.4.1.2.3
retrieving revision 1.1.1.3.4.1.2.4
diff -u -r1.1.1.3.4.1.2.3 -r1.1.1.3.4.1.2.4
--- squid/src/protos.h	3 Jun 2001 19:41:48 -0000	1.1.1.3.4.1.2.3
+++ squid/src/protos.h	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.1.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.1.1.3.4.1.2.3 2001/06/03 19:41:48 serassio Exp $
+ * $Id: protos.h,v 1.1.1.3.4.1.2.4 2001/06/14 20:36:16 serassio Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -714,6 +714,8 @@
 
 extern void serverConnectionsClose(void);
 extern void shut_down(int);
+extern void rotate_logs(int);
+extern void reconfigure(int);
 
 
 extern void start_announce(void *unused);
@@ -957,6 +959,8 @@
 extern void storeDirOpenSwapLogs(void);
 extern void storeDirSwapLog(const StoreEntry *, int op);
 extern void storeDirUpdateSwapSize(int fn, size_t size, int sign);
+extern int storeDirGetBlkSize(const char *path, int *blksize);
+extern int storeDirGetUFSStats(const char *, int *, int *, int *, int *);
 
 /*
  * store_dir_ufs.c
@@ -1223,11 +1227,20 @@
 extern int gethostname(char *, int);
 #endif
 
+/* CygWin & Windows NT Port */ 
+/* win32.c */ 
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+extern int WIN32_Subsystem_Init();
+extern void WIN32_sendSignal(int);
+extern void WIN32_Exit(int);
+extern void WIN32_InstallService(void);
+extern void WIN32_RemoveService(void);
+/* win32lib.c */
 #ifdef _SQUID_MSWIN_
-/* win32.c */
-VOID ServiceExit(int);
-void InstallService(void);
-void RemoveService(void);
-extern int store_key(const char *, DWORD, unsigned char *, int);
+extern int chroot (const char *);
+extern int kill(pid_t, int);
+extern void gettimeofday(struct timeval * ,void *);
+int statfs(const char *, struct statfs *);
+#endif
 #endif
 
Index: squid/src/squid.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/squid.h,v
retrieving revision 1.1.1.3.4.1.2.2
retrieving revision 1.1.1.3.4.1.2.3
diff -u -r1.1.1.3.4.1.2.2 -r1.1.1.3.4.1.2.3
--- squid/src/squid.h	3 Jun 2001 19:41:48 -0000	1.1.1.3.4.1.2.2
+++ squid/src/squid.h	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.1.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: squid.h,v 1.1.1.3.4.1.2.2 2001/06/03 19:41:48 serassio Exp $
+ * $Id: squid.h,v 1.1.1.3.4.1.2.3 2001/06/14 20:36:16 serassio Exp $
  *
  * AUTHOR: Duane Wessels
  *
@@ -435,14 +435,4 @@
 #define SWAP_DIR_SHIFT 24
 #define SWAP_FILE_MASK 0x00FFFFFF
 
-#ifdef _SQUID_MSWIN_
-/* Some tricks for MS Compilers */
-#define SQUID_SERVICE_CONTROL_ROTATE		128
-#define SQUID_SERVICE_CONTROL_RECONFIGURE	129
-#define SQUID_SERVICE_CONTROL_DEBUG			130
-#define SQUID_SERVICE_CONTROL_INTERRUPT     131
-#define SQUID_SERVICE_NAME			"SquidNT2.3Stable4 beta"
-#include "psapi.h"
-#endif
-
 #endif /* SQUID_H */
Index: squid/src/store.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store.c,v
retrieving revision 1.1.1.3.4.5.2.2
retrieving revision 1.1.1.3.4.5.2.3
diff -u -r1.1.1.3.4.5.2.2 -r1.1.1.3.4.5.2.3
--- squid/src/store.c	3 Jun 2001 19:41:48 -0000	1.1.1.3.4.5.2.2
+++ squid/src/store.c	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.5.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store.c,v 1.1.1.3.4.5.2.2 2001/06/03 19:41:48 serassio Exp $
+ * $Id: store.c,v 1.1.1.3.4.5.2.3 2001/06/14 20:36:16 serassio Exp $
  *
  * DEBUG: section 20    Storage Manager
  * AUTHOR: Harvest Derived
Index: squid/src/store_dir.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_dir.c,v
retrieving revision 1.1.1.3.4.2.2.2
retrieving revision 1.1.1.3.4.2.2.3
diff -u -r1.1.1.3.4.2.2.2 -r1.1.1.3.4.2.2.3
--- squid/src/store_dir.c	3 Jun 2001 19:41:49 -0000	1.1.1.3.4.2.2.2
+++ squid/src/store_dir.c	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.2.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir.c,v 1.1.1.3.4.2.2.2 2001/06/03 19:41:49 serassio Exp $
+ * $Id: store_dir.c,v 1.1.1.3.4.2.2.3 2001/06/14 20:36:16 serassio Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -35,6 +35,11 @@
 #define STORE_DIR_C
 #include "squid.h"
 
+/* Windows uses sys/vfs.h */
+#if HAVE_SYS_VFS_H
+#include <sys/vfs.h>
+#endif
+
 const char *SwapDirType[] =
 {
     "ufs",
@@ -278,8 +283,10 @@
 void
 storeDirUpdateSwapSize(int fn, size_t size, int sign)
 {
-    int dirn = (fn >> SWAP_DIR_SHIFT) % Config.cacheSwap.n_configured;
-    int k = ((size + 1023) >> 10) * sign;
+	int dirn = (fn >> SWAP_DIR_SHIFT) % Config.cacheSwap.n_configured;
+    SwapDir *sd = &Config.cacheSwap.swapDirs[dirn];
+	int blks = (size + sd->fs.blksize - 1) / sd->fs.blksize;
+	int k = (blks * sd->fs.blksize >> 10) * sign;
     Config.cacheSwap.swapDirs[dirn].cur_size += k;
     store_swap_size += k;
     if (sign > 0)
@@ -453,4 +460,55 @@
     return n;
 }
 #undef CLEAN_BUF_SZ
+
+int
+storeDirGetBlkSize(const char *path, int *blksize)
+{
+#if HAVE_STATVFS
+    struct statvfs sfs;
+    if (statvfs(path, &sfs)) {
+	debug(50, 1) ("%s: %s\n", path, xstrerror());
+	return 1;
+    }
+    *blksize = (int) sfs.f_frsize;
+#else
+    struct statfs sfs;
+    if (statfs(path, &sfs)) {
+	debug(50, 1) ("%s: %s\n", path, xstrerror());
+	return 1;
+    }
+    *blksize = (int) sfs.f_bsize;
+#endif
+    return 0;
+}
+
+#define fsbtoblk(num, fsbs, bs) \
+    (((fsbs) != 0 && (fsbs) < (bs)) ? \
+            (num) / ((bs) / (fsbs)) : (num) * ((fsbs) / (bs)))
+int
+storeDirGetUFSStats(const char *path, int *totl_kb, int *free_kb, int *totl_in, int *free_in)
+{
+#if HAVE_STATVFS
+    struct statvfs sfs;
+    if (statvfs(path, &sfs)) {
+	debug(50, 1) ("%s: %s\n", path, xstrerror());
+	return 1;
+    }
+    *totl_kb = (int) fsbtoblk(sfs.f_blocks, sfs.f_frsize, 1024);
+    *free_kb = (int) fsbtoblk(sfs.f_bfree, sfs.f_frsize, 1024);
+    *totl_in = (int) sfs.f_files;
+    *free_in = (int) sfs.f_ffree;
+#else
+    struct statfs sfs;
+    if (statfs(path, &sfs)) {
+	debug(50, 1) ("%s: %s\n", path, xstrerror());
+	return 1;
+    }
+    *totl_kb = (int) fsbtoblk(sfs.f_blocks, sfs.f_bsize, 1024);
+    *free_kb = (int) fsbtoblk(sfs.f_bfree, sfs.f_bsize, 1024);
+    *totl_in = (int) sfs.f_files;
+    *free_in = (int) sfs.f_ffree;
+#endif
+    return 0;
+}
 #undef STORE_DIR_C
\ No newline at end of file
